//=============================================================================
//
// file :         PseudoAxesClass.h
//
// description :  Include for the PseudoAxesClass root class.
//                This class is represents the singleton class for
//                the PseudoAxes device class.
//                It contains all properties and methods which the 
//                PseudoAxes requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author:  $
//
// $Revision:  $
//
// $Log:  $
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _PSEUDOAXESCLASS_H
#define _PSEUDOAXESCLASS_H

#include <tango.h>
#include <PseudoAxes.h>


namespace PseudoAxes_ns
{//=====================================
//	Define classes for attributes
//=====================================
class pseudoAxisNamesAttrib: public Tango::SpectrumAttr
{
public:
	pseudoAxisNamesAttrib():SpectrumAttr("pseudoAxisNames", Tango::DEV_STRING, Tango::READ, 100) {};
	~pseudoAxisNamesAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PseudoAxes *>(dev))->read_pseudoAxisNames(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PseudoAxes *>(dev))->is_pseudoAxisNames_allowed(ty);}
};

class parametersAttrib: public Tango::SpectrumAttr
{
public:
	parametersAttrib():SpectrumAttr("parameters", Tango::DEV_DOUBLE, Tango::READ_WRITE, 100) {};
	~parametersAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PseudoAxes *>(dev))->read_parameters(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PseudoAxes *>(dev))->write_parameters(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PseudoAxes *>(dev))->is_parameters_allowed(ty);}
};

class parametersNamesAttrib: public Tango::SpectrumAttr
{
public:
	parametersNamesAttrib():SpectrumAttr("parametersNames", Tango::DEV_STRING, Tango::READ, 100) {};
	~parametersNamesAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PseudoAxes *>(dev))->read_parametersNames(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PseudoAxes *>(dev))->is_parametersNames_allowed(ty);}
};

class modeNamesAttrib: public Tango::SpectrumAttr
{
public:
	modeNamesAttrib():SpectrumAttr("modeNames", Tango::DEV_STRING, Tango::READ, 100) {};
	~modeNamesAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PseudoAxes *>(dev))->read_modeNames(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PseudoAxes *>(dev))->is_modeNames_allowed(ty);}
};

class initializedAttrib: public Tango::Attr
{
public:
	initializedAttrib():Attr("initialized", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~initializedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PseudoAxes *>(dev))->read_initialized(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PseudoAxes *>(dev))->write_initialized(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PseudoAxes *>(dev))->is_initialized_allowed(ty);}
};

class modeAttrib: public Tango::Attr
{
public:
	modeAttrib():Attr("mode", Tango::DEV_STRING, Tango::READ_WRITE) {};
	~modeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PseudoAxes *>(dev))->read_mode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PseudoAxes *>(dev))->write_mode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PseudoAxes *>(dev))->is_mode_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class ApplyCmd : public Tango::Command
{
public:
	ApplyCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ApplyCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ApplyCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PseudoAxes *>(dev))->is_Apply_allowed(any);}
};



class AxisInitClass : public Tango::Command
{
public:
	AxisInitClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisInitClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisInitClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PseudoAxes *>(dev))->is_AxisInit_allowed(any);}
};



//
// The PseudoAxesClass singleton definition
//

class PseudoAxesClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static PseudoAxesClass *init(const char *);
	static PseudoAxesClass *instance();
	~PseudoAxesClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	PseudoAxesClass(string &);
	static PseudoAxesClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace PseudoAxes_ns

#endif // _PSEUDOAXESCLASS_H
